// Woot, LUA!!!!!!
#include <lua.h>
#include <lauxlib.h>
#include <lualib.h>

#include "def.h"
#include "log.h"
#include "pilot.h"
#include "ai.h"

// == AI ======================================================
// -- AI will follow basic tasks defined from Lua AI scripts.
//  -- If task is NULL, AI will run "control" task.
//  -- Task is continued every frame.
//  -- "control" task is a special task that *must* exist in
//      any given Pilot AI (missiles, and suck will use "seek".
//    -- "control" task is not permanent, but transitory.
//    -- "control" task sets another task.
//  -- "control" task is also run at a set rate (depending on
//      Lua global "control_rate") to choose optimal behaviour
//      (task).
// ============================================================


// Basic task.
// name   : Tasks name (Lua function.)
// target : Target, this will depend on the task itself.
typedef struct {
  char* name;
  void* target;
} Task;

// Global Lua interpreter.
static lua_State* L = NULL;

int ai_init(void) {
  L = luaL_newstate();
  if(L == NULL)
    return -1;

  return 0;
}

void ai_exit(void) {
  lua_close(L);
}

// Heart of hearts of the ai!! Brains of the pilot.
void ai_think(Pilot* pilot) {
  if(pilot->action == NULL) {
    // Idle git!
  }
}

